/**

	MC - Memory Controller
	
	File			:	Controller Definition

	Created by		:	Reznichenko Anton aka AlterVision
						mailto:me@av13.ru
						http://www.av13.ru

	Project started :	30 november 2008 - 17:00
	Last edited		:	31 november 2008 - 00:13

	Uses			:	<windows.h> kernel32.dll

	Describtion		:
		
		Memory controller is used to allocate memory for the application
		and replace default malloc and free functions.

		It uses bitmap storage algorithm to keep informaion about memory,
		stored in 8-byte blocks.

	Algorithm		:	Heappie Memory Control Algorithm

		All the heap memory is parted into special small elements, called
		"heappies" which store data and bitmaps. Each heap has HEAP_SIZE 
		cells each of HEAP_CELL bytes, so total memory, that can be kept
		by one heappie is HEAP_SIZE * HEAP_CELL.
		If one heappie is not enough to store the full object, it is 
		rejected - it is bad, but can be fixed by using larger HEAP_CELL.
		If current heappie is too small to store full object, one more 
		heappie is created. All heappies form one large heappie ring.
		If heappie is empty, it can be automatically deleted to maximize
		free computer memory. If it is needed, you should set HEAP_MINIMIZE
		to 1 in order to eneble heappie killing algorithm.

		You can change HEAP_SIZE, HEAP_CELL, HEAP_MINIMIZE parameters 
		in "mc.cpp" file.

	More Info		:	http://www.av13.ru/arts/mc-heappie/
		
*/

#ifndef MC_H__
#define MC_H__

//
// Module Interface
//

// My Definition Analogs - j4f
void * mc_alloc ( size_t size );
void mc_delete ( void * mc_block );

#endif
// eof